<template>
  <div class="px-3 pt-3">
    <v-card-title> </v-card-title>
    <v-data-table
      data-app
      :headers="headers"
      :items="venues"
      :search="search"
      sort-by="venueId"
      class="elevation-1"
      loading
      loading-text="Loading... Please wait"
      @current-items="getFiltered"
    >
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Venues</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <download-csv
            class="btn btn-default"
            :data="filteredData"
            name="venues.csv"
          >
            Download CSV
          </download-csv>
          <v-spacer></v-spacer>
          <v-btn color="primary" dark class="mb-2" @click="createItem">
            New Venue
          </v-btn>
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
          <v-dialog v-model="dialog" max-width="500px">
            <v-card>
              <v-card-title>
                <span class="headline">{{ formTitle }}</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.venueId"
                        label="Venue Id"
                        disabled
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-select
                        :items="venueTypes"
                        label="Venue"
                        v-model="editedItem.type"
                        item-value="val"
                        item-text="name"
                      >
                      </v-select>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.address"
                        label="Address"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-text-field
                        v-model="editedItem.postalCode"
                        label="Postal code"
                      ></v-text-field>
                    </v-col>
                    <v-col cols="12" sm="6" md="4">
                      <v-checkbox v-model="editedItem.isActive" label=" Active">
                      </v-checkbox>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue darken-1" text @click="close">
                  Cancel
                </v-btn>
                <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:item.actions="{ item }">
        <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil </v-icon>
      </template>
    </v-data-table>
  </div>
</template>

<script>
import venueController from "../controllers/venue.controller";
import swal from "sweetalert2";
import auth from "../controllers/auth.controller";
export default {
  name: "Venues",
  data: function () {
    return {
      menu: false,
      modal1: false,
      menu2: false,
      dialog: false,
      dialogDelete: false,
      search: "",
      venues: [],
      editedIndex: -1,
      headers: [
        { text: "Venue Id", value: "venueId" },
        { text: "Address", value: "address" },
        { text: "Postal code", value: "postalCode" },
        { text: "Type", value: "type" },
        { text: "Active", value: "isActive" },
        { text: "Actions", value: "actions", sortable: false },
      ],
      editedItem: {
        venueId: 0,
        address: "",
        postalCode: "",
        type: "undefined",
        isActive: false,
      },
      venueTypes: [
        { val: 0, name: "Gym" },
        { val: 1, name: "Public" },
        { val: 2, name: "Home" },
      ],
    };
  },
  methods: {
    getVenueType(venueEnum) {
      switch (venueEnum) {
        case 0:
          return "Gym";
        case 1:
          return "Public";
        case 2:
          return "Home";
        default:
          return "Undefined";
      }
    },
    modalClosed: function (data) {
      if (data) {
        this.venues = data;
      }

      this.showModal = false;
    },
    async getVenues() {
      try {
        let res = await venueController.getVenues();
        if (res.status === 200) {
          this.venues = res.data;
          this.venues.forEach(venue => {
            venue.type = this.getVenueType(venue.type);
          })
        } else {
          swal.fire({
            icon: "error",
            title: "Oops.. could not get venues..",
          });
        }
      } catch (e) {
        swal.fire({
          icon: "error",
          title: "Oops.. could not get venues..",
        });
      }
    },
    getFiltered(e) {
      this.filteredData = e;
    },
    editItem(item) {
      this.editedIndex = this.venues.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    createItem() {
      this.editedItem = {};
      this.editedIndex = 0;
      this.dialog = true;
    },

    deleteItem(item) {
      this.editedIndex = this.venues.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialogDelete = true;
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    closeDelete() {
      this.dialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    async save() {
      try {
        if (!(await auth.isValidZipCode(this.editedItem.postalCode))) {
          swal.fire({
            icon: "warning",
            title: "invalid zipCode",
          });

          return;
        }
        if (this.editedIndex > 0) {
          const venueId = this.editedItem.venueId;
          const res = await venueController.putVenue(venueId, this.editedItem);
          if (res.status === 204) {
            Object.assign(this.venues[this.editedIndex], this.editedItem);
            this.venues[this.editedIndex].type = this.getVenueType(this.venues[this.editedIndex].type);
            swal.fire("Success", "Venue was updated", "success");
          } else {
            swal.fire({
              icon: "error",
              title: "Oops...",
              text: "Something went wrong!",
            });
          }
        } else if (this.editedIndex == 0) {
          const res = await venueController.postVenue(this.editedItem);
          if (res.status === 201) {
            this.venues.push(res.data);
            swal.fire("Success", "New venue was created", "success");
          } else {
            swal.fire({
              icon: "error",
              title: "Oops...",
              text: "Something went wrong!",
            });
          }
        } else {
          this.venues.push(this.editedItem);
        }
      } catch (e) {
        swal.fire({
          icon: "error",
          title: "Oops...",
          text: "Something went wrong!",
        });
      }

      this.close();
    },
  },
  computed: {
    formTitle() {
      return this.editedIndex === -1 ? "New Item" : "Edit Item";
    },
  },

  watch: {
    dialog(val) {
      val || this.close();
    },
    dialogDelete(val) {
      val || this.closeDelete();
    },
  },
  async mounted() {
    await this.getVenues();
  },
};
</script>

<style>
</style>
